# frozen_string_literal: true

module Takwimu
  module Sidekiq
    class ServerMiddleware

      def initialize(options = {})

      end

      def call worker, msg, queue
        begin
          worker_name = worker.class.name.gsub('::', '.')
          worker_index = Sidekiq.options[:index] || 0

          statsd_client = Takwimu.config.statsd
          hostname = Takwimu.config.hostname

          reporter = Takwimu::Reporter.new(statsd: statsd_client, sample_rate: sample_rate, hostname: hostname)

          metric_prefix = "#{worker_index}.#{worker_name}"

          #log out GC stats

          yield

        rescue => e
          raise e
        ensure
          #log out GC stats

        end
      end
    end
  end
end
